Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4671)
@@ -27,4 +27,13 @@
 ! -----------------
 ! $Id$
+! Radiative transfer model RTM version 4.1
+! - Implementation of downward facing USM and LSM surfaces
+! - Restructuralization EB call
+! - Improved debug logging
+! - Removal of deprecated CSV inputs
+! - Bugfixes
+! Author: J. Resler (Institute of Computer Science, Prague)
+!
+! 4669 2020-09-09 13:43:47Z pavelkrc
 ! Fix calculation of force_radiation_call
 !
@@ -255,5 +264,4 @@
 !> fraq(0,m) + fraq(1,m) = 0?!
 !> @todo Use unit 90 for OPEN/CLOSE of input files (FK)
-!> @todo Remove reading of old csv inputs
 !--------------------------------------------------------------------------------------------------!
  MODULE urban_surface_mod
@@ -280,7 +288,9 @@
     USE basic_constants_and_equations_mod,                                                         &
         ONLY:  c_p,                                                                                &
+               degc_to_k,                                                                          &
                g,                                                                                  &
                kappa,                                                                              &
                l_v,                                                                                &
+               magnus_tl,                                                                       &
                pi,                                                                                 &
                r_d,                                                                                &
@@ -372,6 +382,10 @@
     USE radiation_model_mod,                                                                       &
         ONLY:  albedo_type,                                                                        &
+               dirname,                                                                            &
+               diridx,                                                                             &
+               dirint,                                                                             &
                force_radiation_call,                                                               &
                id,                                                                                 &
+               idown,                                                                              &
                ieast,                                                                              &
                inorth,                                                                             &
@@ -379,4 +393,5 @@
                iup,                                                                                &
                iwest,                                                                              &
+               nd,                                                                                 &
                nz_urban_b,                                                                         &
                nz_urban_t,                                                                         &
@@ -404,4 +419,5 @@
                ind_veg_wall,                                                                       &
                ind_wat_win,                                                                        &
+               surf_type,                                                                          &
                surf_usm_h,                                                                         &
                surf_usm_v,                                                                         &
@@ -461,14 +477,8 @@
 !-- Configuration parameters (they can be setup in PALM config)
     LOGICAL ::  force_radiation_call_l = .FALSE.   !< flag parameter for unscheduled radiation model calls
-    LOGICAL ::  read_wall_temp_3d = .FALSE.        !<
-    LOGICAL ::  usm_anthropogenic_heat = .FALSE.   !< flag parameter indicating wheather the anthropogenic heat sources
-                                                   !< (e.g.transportation) are used
-    LOGICAL ::  usm_material_model = .TRUE.        !< flag parameter indicating wheather the  model of heat in materials is used
     LOGICAL ::  usm_wall_mod = .FALSE.             !< reduces conductivity of the first 2 wall layers by factor 0.1
 
 
     INTEGER(iwp) ::  building_type = 1               !< default building type (preleminary setting)
-    INTEGER(iwp) ::  land_category = 2               !< default category for land surface
-    INTEGER(iwp) ::  pedestrian_category = 2         !< default category for wall surface in pedestrian zone
     INTEGER(iwp) ::  roof_category = 2               !< default category for root surface
     INTEGER(iwp) ::  wall_category = 2               !< default category for wall surface over pedestrian zone
@@ -640,6 +650,4 @@
 
     REAL(wp)  ::  ground_floor_level = 4.0_wp  !< default ground floor level
-    REAL(wp)  ::  roof_height_limit  = 4.0_wp  !< height to distinguish between land surfaces and roofs
-
 
 !
@@ -650,35 +658,13 @@
     REAL(wp), DIMENSION(0:135,1:7) ::  building_pars  !<
 !
-!-- Type for surface temperatures at vertical walls. Is not necessary for horizontal walls.
-    TYPE t_surf_vertical
-       REAL(wp), DIMENSION(:), ALLOCATABLE         ::  t  !<
-    END TYPE t_surf_vertical
-!
-!-- Type for wall temperatures at vertical walls. Is not necessary for horizontal walls.
-    TYPE t_wall_vertical
-       REAL(wp), DIMENSION(:,:), ALLOCATABLE       ::  t  !<
-    END TYPE t_wall_vertical
-
-    TYPE surf_type_usm
-       REAL(wp), DIMENSION(:),   ALLOCATABLE ::  var_usm_1d  !< 1D prognostic variable
-       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  var_usm_2d  !< 2D prognostic variable
-    END TYPE surf_type_usm
-
-    TYPE(surf_type_usm), POINTER  ::  m_liq_usm_h    !< liquid water reservoir (m), horizontal surface elements
-    TYPE(surf_type_usm), POINTER  ::  m_liq_usm_h_p  !< progn. liquid water reservoir (m), horizontal surface elements
-
-    TYPE(surf_type_usm), TARGET   ::  m_liq_usm_h_1  !<
-    TYPE(surf_type_usm), TARGET   ::  m_liq_usm_h_2  !<
-
-    TYPE(surf_type_usm), TARGET   ::  tm_liq_usm_h_m  !< liquid water reservoir tendency (m), horizontal surface elements
-!
-!-- Anthropogenic heat sources
-    INTEGER(iwp)                                   ::  naheatlayers = 1  !< number of layers of anthropogenic heat
-
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE        ::  aheat             !< daily average of anthropogenic heat (W/m2)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE          ::  aheatprof         !< diurnal profiles of anthropogenic heat
-                                                                         !< for particular layers
-
-!
+!-- Type for 1d surface variables as surface temperature and liquid water reservoir
+    TYPE surf_type_1d_usm
+       REAL(wp), DIMENSION(:), ALLOCATABLE         ::  val  !<
+    END TYPE surf_type_1d_usm
+!
+!-- Type for 2d surface variables as wall temperature
+    TYPE surf_type_2d_usm
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE       ::  val  !<
+    END TYPE surf_type_2d_usm
 !-- Wall surface model
 !-- Wall surface model constants
@@ -688,12 +674,4 @@
 
     INTEGER(iwp)                                   ::  soil_type     !<
-
-
-    REAL(wp), DIMENSION(nzb_wall:nzt_wall)         ::  zwn_default        = (/0.0242_wp, 0.0969_wp, 0.346_wp, 1.0_wp /)
-    REAL(wp), DIMENSION(nzb_wall:nzt_wall)         ::  zwn_default_green  = (/0.25_wp,   0.5_wp,    0.75_wp,  1.0_wp /)
-                                                                          !< normalized soil, wall and roof, window and
-                                                                          !< green layer depths (m/m)
-    REAL(wp), DIMENSION(nzb_wall:nzt_wall)         ::  zwn_default_window = (/0.25_wp,   0.5_wp,    0.75_wp,  1.0_wp /)
-
 
     REAL(wp)  ::  m_total                  = 0.0_wp    !< weighted total water content of the soil (m3/m3)
@@ -706,116 +684,83 @@
     REAL(wp)  ::  window_inner_temperature = 295.0_wp  !< temperature of the inner window
                                                        !< surface (~22 degrees C) (K)
-
 !
 !-- Surface and material model variables for walls, ground, roofs
-    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  zwn                 !< normalized wall layer depths (m)
-    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  zwn_green           !< normalized green layer depths (m)
-    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  zwn_window          !< normalized window layer depths (m)
-
-    REAL(wp), DIMENSION(:), POINTER                ::  t_surf_green_h      !<
-    REAL(wp), DIMENSION(:), POINTER                ::  t_surf_green_h_p    !<
-    REAL(wp), DIMENSION(:), POINTER                ::  t_surf_wall_h       !<
-    REAL(wp), DIMENSION(:), POINTER                ::  t_surf_wall_h_p     !<
-    REAL(wp), DIMENSION(:), POINTER                ::  t_surf_window_h     !<
-    REAL(wp), DIMENSION(:), POINTER                ::  t_surf_window_h_p   !<
-
-    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    ::  t_surf_green_h_1    !<
-    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    ::  t_surf_green_h_2    !<
-    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    ::  t_surf_wall_h_1     !<
-    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    ::  t_surf_wall_h_2     !<
-    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    ::  t_surf_window_h_1   !<
-    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    ::  t_surf_window_h_2   !<
-
-    TYPE(t_surf_vertical), DIMENSION(:), POINTER   ::  t_surf_green_v      !<
-    TYPE(t_surf_vertical), DIMENSION(:), POINTER   ::  t_surf_green_v_p    !<
-    TYPE(t_surf_vertical), DIMENSION(:), POINTER   ::  t_surf_wall_v       !<
-    TYPE(t_surf_vertical), DIMENSION(:), POINTER   ::  t_surf_wall_v_p     !<
-    TYPE(t_surf_vertical), DIMENSION(:), POINTER   ::  t_surf_window_v     !<
-    TYPE(t_surf_vertical), DIMENSION(:), POINTER   ::  t_surf_window_v_p   !<
-
-    TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  ::  t_surf_green_v_1    !<
-    TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  ::  t_surf_green_v_2    !<
-    TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  ::  t_surf_wall_v_1     !<
-    TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  ::  t_surf_wall_v_2     !<
-    TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  ::  t_surf_window_v_1   !<
-    TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  ::  t_surf_window_v_2   !<
+    TYPE(surf_type_1d_usm), DIMENSION(:), POINTER   ::  t_surf_green_h      !<
+    TYPE(surf_type_1d_usm), DIMENSION(:), POINTER   ::  t_surf_green_h_p    !<
+    TYPE(surf_type_1d_usm), DIMENSION(:), POINTER   ::  t_surf_wall_h       !<
+    TYPE(surf_type_1d_usm), DIMENSION(:), POINTER   ::  t_surf_wall_h_p     !<
+    TYPE(surf_type_1d_usm), DIMENSION(:), POINTER   ::  t_surf_window_h     !<
+    TYPE(surf_type_1d_usm), DIMENSION(:), POINTER   ::  t_surf_window_h_p   !<
+
+    TYPE(surf_type_1d_usm), DIMENSION(0:1), TARGET  ::  t_surf_green_h_1    !<
+    TYPE(surf_type_1d_usm), DIMENSION(0:1), TARGET  ::  t_surf_green_h_2    !<
+    TYPE(surf_type_1d_usm), DIMENSION(0:1), TARGET  ::  t_surf_wall_h_1     !<
+    TYPE(surf_type_1d_usm), DIMENSION(0:1), TARGET  ::  t_surf_wall_h_2     !<
+    TYPE(surf_type_1d_usm), DIMENSION(0:1), TARGET  ::  t_surf_window_h_1   !<
+    TYPE(surf_type_1d_usm), DIMENSION(0:1), TARGET  ::  t_surf_window_h_2   !<
+
+    TYPE(surf_type_1d_usm), DIMENSION(:), POINTER   ::  t_surf_green_v      !<
+    TYPE(surf_type_1d_usm), DIMENSION(:), POINTER   ::  t_surf_green_v_p    !<
+    TYPE(surf_type_1d_usm), DIMENSION(:), POINTER   ::  t_surf_wall_v       !<
+    TYPE(surf_type_1d_usm), DIMENSION(:), POINTER   ::  t_surf_wall_v_p     !<
+    TYPE(surf_type_1d_usm), DIMENSION(:), POINTER   ::  t_surf_window_v     !<
+    TYPE(surf_type_1d_usm), DIMENSION(:), POINTER   ::  t_surf_window_v_p   !<
+
+    TYPE(surf_type_1d_usm), DIMENSION(0:3), TARGET  ::  t_surf_green_v_1    !<
+    TYPE(surf_type_1d_usm), DIMENSION(0:3), TARGET  ::  t_surf_green_v_2    !<
+    TYPE(surf_type_1d_usm), DIMENSION(0:3), TARGET  ::  t_surf_wall_v_1     !<
+    TYPE(surf_type_1d_usm), DIMENSION(0:3), TARGET  ::  t_surf_wall_v_2     !<
+    TYPE(surf_type_1d_usm), DIMENSION(0:3), TARGET  ::  t_surf_window_v_1   !<
+    TYPE(surf_type_1d_usm), DIMENSION(0:3), TARGET  ::  t_surf_window_v_2   !<
 
 !
 !-- Energy balance variables
-!-- Parameters of the land, roof and wall surfaces
-    REAL(wp), DIMENSION(:,:), POINTER                ::  fc_h          !<
-    REAL(wp), DIMENSION(:,:), POINTER                ::  rootfr_h      !<
-    REAL(wp), DIMENSION(:,:), POINTER                ::  swc_h         !<
-    REAL(wp), DIMENSION(:,:), POINTER                ::  swc_h_p       !<
-    REAL(wp), DIMENSION(:,:), POINTER                ::  swc_res_h     !<
-    REAL(wp), DIMENSION(:,:), POINTER                ::  swc_sat_h     !<
-    REAL(wp), DIMENSION(:,:), POINTER                ::  t_green_h     !<
-    REAL(wp), DIMENSION(:,:), POINTER                ::  t_green_h_p   !<
-    REAL(wp), DIMENSION(:,:), POINTER                ::  t_wall_h      !<
-    REAL(wp), DIMENSION(:,:), POINTER                ::  t_wall_h_p    !<
-    REAL(wp), DIMENSION(:,:), POINTER                ::  wilt_h        !<
-    REAL(wp), DIMENSION(:,:), POINTER                ::  t_window_h    !<
-    REAL(wp), DIMENSION(:,:), POINTER                ::  t_window_h_p  !<
-
-
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    ::  fc_h_1        !<
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    ::  rootfr_h_1    !<
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    ::  swc_h_1       !<
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    ::  swc_h_2       !<
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    ::  swc_res_h_1   !<
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    ::  swc_sat_h_1   !<
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    ::  t_green_h_1   !<
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    ::  t_green_h_2   !<
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    ::  t_wall_h_1    !<
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    ::  t_wall_h_2    !<
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    ::  wilt_h_1      !<
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    ::  t_window_h_1  !<
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    ::  t_window_h_2  !<
-
-
-    TYPE(t_wall_vertical), DIMENSION(:), POINTER   ::  t_green_v     !<
-    TYPE(t_wall_vertical), DIMENSION(:), POINTER   ::  t_green_v_p   !<
-    TYPE(t_wall_vertical), DIMENSION(:), POINTER   ::  t_wall_v      !<
-    TYPE(t_wall_vertical), DIMENSION(:), POINTER   ::  t_wall_v_p    !<
-    TYPE(t_wall_vertical), DIMENSION(:), POINTER   ::  t_window_v    !<
-    TYPE(t_wall_vertical), DIMENSION(:), POINTER   ::  t_window_v_p  !<
-
-
-    TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  ::  t_green_v_1   !<
-    TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  ::  t_green_v_2   !<
-    TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  ::  t_wall_v_1    !<
-    TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  ::  t_wall_v_2    !<
-    TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  ::  t_window_v_1  !<
-    TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  ::  t_window_v_2  !<
-
-!
-!-- Surface and material parameter classes (surface_type)
-!-- Albedo, emissivity, lambda_surf, roughness, thickness, volumetric heat capacity, thermal conductivity
-    CHARACTER(12), DIMENSION(:), ALLOCATABLE  ::  surface_type_names    !< names of wall types (used only for reports)
-
-    INTEGER(iwp)                              ::  n_surface_types       !< number of the wall type categories
-
-    INTEGER(iwp), PARAMETER                   ::  ialbedo  = 1          !< albedo of the surface
-    INTEGER(iwp), PARAMETER                   ::  icsurf   = 6          !< Surface skin layer heat capacity (J m-2 K-1 )
-    INTEGER(iwp), PARAMETER                   ::  iemiss   = 2          !< emissivity of the surface
-    INTEGER(iwp), PARAMETER                   ::  ilambdah = 9          !< thermal conductivity lambda H
-                                                                        !< of the wall (W m-1 K-1 )
-    INTEGER(iwp), PARAMETER                   ::  ilambdas = 3          !< heat conductivity lambda S between surface
-                                                                        !< and material ( W m-2 K-1 )
-    INTEGER(iwp), PARAMETER                   ::  irhoC    = 8          !< volumetric heat capacity rho*C of
-                                                                        !< the material ( J m-3 K-1 )
-    INTEGER(iwp), PARAMETER                   ::  irough   = 4          !< roughness length z0 for movements
-    INTEGER(iwp), PARAMETER                   ::  iroughh  = 5          !< roughness length z0h for scalars
-                                                                        !< (heat, humidity,...)
-    INTEGER(iwp), PARAMETER                   ::  ithick   = 7          !< thickness of the surface (wall, roof, land) (m)
-    INTEGER(iwp), PARAMETER                   ::  n_surface_params = 9  !< number of parameters for each type of the wall
-
-
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE   ::  surface_type_codes    !< codes of wall types
-
-
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE     ::  surface_params        !< parameters of wall types
-
-!
+!-- Parameters of the land, roof and wall surfaces (only for horizontal upward surfaces)
+    TYPE(surf_type_2d_usm), DIMENSION(:), POINTER   ::  fc_h          !<
+    TYPE(surf_type_2d_usm), DIMENSION(:), POINTER   ::  rootfr_h      !<
+    TYPE(surf_type_2d_usm), DIMENSION(:), POINTER   ::  swc_h         !<
+    TYPE(surf_type_2d_usm), DIMENSION(:), POINTER   ::  swc_h_p       !<
+    TYPE(surf_type_2d_usm), DIMENSION(:), POINTER   ::  swc_res_h     !<
+    TYPE(surf_type_2d_usm), DIMENSION(:), POINTER   ::  swc_sat_h     !<
+    TYPE(surf_type_2d_usm), DIMENSION(:), POINTER   ::  t_green_h     !<
+    TYPE(surf_type_2d_usm), DIMENSION(:), POINTER   ::  t_green_h_p   !<
+    TYPE(surf_type_2d_usm), DIMENSION(:), POINTER   ::  t_wall_h      !<
+    TYPE(surf_type_2d_usm), DIMENSION(:), POINTER   ::  t_wall_h_p    !<
+    TYPE(surf_type_2d_usm), DIMENSION(:), POINTER   ::  wilt_h        !<
+    TYPE(surf_type_2d_usm), DIMENSION(:), POINTER   ::  t_window_h    !<
+    TYPE(surf_type_2d_usm), DIMENSION(:), POINTER   ::  t_window_h_p  !<
+
+
+    TYPE(surf_type_2d_usm), DIMENSION(0:1), TARGET  ::  fc_h_1        !<
+    TYPE(surf_type_2d_usm), DIMENSION(0:1), TARGET  ::  rootfr_h_1    !<
+    TYPE(surf_type_2d_usm), DIMENSION(0:1), TARGET  ::  swc_h_1       !<
+    TYPE(surf_type_2d_usm), DIMENSION(0:1), TARGET  ::  swc_h_2       !<
+    TYPE(surf_type_2d_usm), DIMENSION(0:1), TARGET  ::  swc_res_h_1   !<
+    TYPE(surf_type_2d_usm), DIMENSION(0:1), TARGET  ::  swc_sat_h_1   !<
+    TYPE(surf_type_2d_usm), DIMENSION(0:1), TARGET  ::  t_green_h_1   !<
+    TYPE(surf_type_2d_usm), DIMENSION(0:1), TARGET  ::  t_green_h_2   !<
+    TYPE(surf_type_2d_usm), DIMENSION(0:1), TARGET  ::  t_wall_h_1    !<
+    TYPE(surf_type_2d_usm), DIMENSION(0:1), TARGET  ::  t_wall_h_2    !<
+    TYPE(surf_type_2d_usm), DIMENSION(0:1), TARGET  ::  wilt_h_1      !<
+    TYPE(surf_type_2d_usm), DIMENSION(0:1), TARGET  ::  t_window_h_1  !<
+    TYPE(surf_type_2d_usm), DIMENSION(0:1), TARGET  ::  t_window_h_2  !<
+
+    TYPE(surf_type_2d_usm), DIMENSION(:), POINTER   ::  t_green_v     !<
+    TYPE(surf_type_2d_usm), DIMENSION(:), POINTER   ::  t_green_v_p   !<
+    TYPE(surf_type_2d_usm), DIMENSION(:), POINTER   ::  t_wall_v      !<
+    TYPE(surf_type_2d_usm), DIMENSION(:), POINTER   ::  t_wall_v_p    !<
+    TYPE(surf_type_2d_usm), DIMENSION(:), POINTER   ::  t_window_v    !<
+    TYPE(surf_type_2d_usm), DIMENSION(:), POINTER   ::  t_window_v_p  !<
+    TYPE(surf_type_2d_usm), DIMENSION(0:3), TARGET  ::  t_green_v_1   !<
+    TYPE(surf_type_2d_usm), DIMENSION(0:3), TARGET  ::  t_green_v_2   !<
+    TYPE(surf_type_2d_usm), DIMENSION(0:3), TARGET  ::  t_wall_v_1    !<
+    TYPE(surf_type_2d_usm), DIMENSION(0:3), TARGET  ::  t_wall_v_2    !<
+    TYPE(surf_type_2d_usm), DIMENSION(0:3), TARGET  ::  t_window_v_1  !<
+    TYPE(surf_type_2d_usm), DIMENSION(0:3), TARGET  ::  t_window_v_2  !<
+    TYPE(surf_type_1d_usm), DIMENSION(:), POINTER   ::  m_liq_usm_h    !< liquid water reservoir (m), horizontal surface elements
+    TYPE(surf_type_1d_usm), DIMENSION(:), POINTER   ::  m_liq_usm_h_p  !< progn. liquid water reservoir (m), horizontal surface elements
+    TYPE(surf_type_1d_usm), DIMENSION(0:1), TARGET  ::  m_liq_usm_h_1  !<
+    TYPE(surf_type_1d_usm), DIMENSION(0:1), TARGET  ::  m_liq_usm_h_2  !<
+    TYPE(surf_type_1d_usm), DIMENSION(0:1), TARGET  ::  tm_liq_usm_h_m  !< liquid water reservoir tendency (m), horizontal surface elements
 !-- Interfaces of subroutines accessed from outside of this module
     INTERFACE usm_3d_data_averaging
@@ -851,12 +796,4 @@
     END INTERFACE usm_init_arrays
 
-    INTERFACE usm_material_heat_model
-       MODULE PROCEDURE usm_material_heat_model
-    END INTERFACE usm_material_heat_model
-
-    INTERFACE usm_green_heat_model
-       MODULE PROCEDURE usm_green_heat_model
-    END INTERFACE usm_green_heat_model
-
     INTERFACE usm_parin
        MODULE PROCEDURE usm_parin
@@ -868,7 +805,7 @@
     END INTERFACE usm_rrd_local
 
-    INTERFACE usm_surface_energy_balance
-       MODULE PROCEDURE usm_surface_energy_balance
-    END INTERFACE usm_surface_energy_balance
+    INTERFACE usm_energy_balance
+       MODULE PROCEDURE usm_energy_balance
+    END INTERFACE usm_energy_balance
 
     INTERFACE usm_swap_timelevel
@@ -894,8 +831,7 @@
            usm_init,                                                                               &
            usm_init_arrays,                                                                        &
-           usm_material_heat_model,                                                                &
            usm_parin,                                                                              &
            usm_rrd_local,                                                                          &
-           usm_surface_energy_balance,                                                             &
+           usm_energy_balance,                                                                     &
            usm_swap_timelevel,                                                                     &
            usm_wrd_local,                                                                          &
@@ -912,7 +848,4 @@
            t_window_h,                                                                             &
            t_window_v,                                                                             &
-           usm_anthropogenic_heat,                                                                 &
-           usm_green_heat_model,                                                                   &
-           usm_material_model,                                                                     &
            usm_wall_mod
 
@@ -941,6 +874,8 @@
 !-- Allocate radiation arrays which are part of the new data type.
 !-- For horizontal surfaces.
-    ALLOCATE ( surf_usm_h%surfhf(1:surf_usm_h%ns)    )
-    ALLOCATE ( surf_usm_h%rad_net_l(1:surf_usm_h%ns) )
+    DO  l = 0, 1
+       ALLOCATE ( surf_usm_h(l)%surfhf(1:surf_usm_h(l)%ns)    )
+       ALLOCATE ( surf_usm_h(l)%rad_net_l(1:surf_usm_h(l)%ns) )
+    ENDDO
 !
 !-- For vertical surfaces
@@ -954,9 +889,11 @@
 !-- Allocate arrays for wall surface model and define pointers
 !-- Allocate array of wall types and wall parameters
-    ALLOCATE ( surf_usm_h%surface_types(1:surf_usm_h%ns)      )
-    ALLOCATE ( surf_usm_h%building_type(1:surf_usm_h%ns)      )
-    ALLOCATE ( surf_usm_h%building_type_name(1:surf_usm_h%ns) )
-    surf_usm_h%building_type      = 0
-    surf_usm_h%building_type_name = 'none'
+    DO  l = 0, 1
+       ALLOCATE ( surf_usm_h(l)%surface_types(1:surf_usm_h(l)%ns)      )
+       ALLOCATE ( surf_usm_h(l)%building_type(1:surf_usm_h(l)%ns)      )
+       ALLOCATE ( surf_usm_h(l)%building_type_name(1:surf_usm_h(l)%ns) )
+       surf_usm_h(l)%building_type      = 0
+       surf_usm_h(l)%building_type_name = 'none'
+    ENDDO
     DO  l = 0, 3
        ALLOCATE ( surf_usm_v(l)%surface_types(1:surf_usm_v(l)%ns)      )
@@ -969,7 +906,9 @@
 !-- Allocate albedo_type and albedo. Each surface element has 3 values, 0: wall fraction,
 !-- 1: green fraction, 2: window fraction.
-    ALLOCATE ( surf_usm_h%albedo_type(1:surf_usm_h%ns,0:2) )
-    ALLOCATE ( surf_usm_h%albedo(1:surf_usm_h%ns,0:2)      )
-    surf_usm_h%albedo_type = albedo_type
+    DO  l = 0, 1
+       ALLOCATE ( surf_usm_h(l)%albedo_type(1:surf_usm_h(l)%ns,0:2) )
+       ALLOCATE ( surf_usm_h(l)%albedo(1:surf_usm_h(l)%ns,0:2)      )
+       surf_usm_h(l)%albedo_type = albedo_type
+    ENDDO
     DO  l = 0, 3
        ALLOCATE ( surf_usm_v(l)%albedo_type(1:surf_usm_v(l)%ns,0:2) )
@@ -980,6 +919,8 @@
 !
 !-- Allocate indoor target temperature for summer and winter
-    ALLOCATE ( surf_usm_h%target_temp_summer(1:surf_usm_h%ns) )
-    ALLOCATE ( surf_usm_h%target_temp_winter(1:surf_usm_h%ns) )
+    DO  l = 0, 1
+       ALLOCATE ( surf_usm_h(l)%target_temp_summer(1:surf_usm_h(l)%ns) )
+       ALLOCATE ( surf_usm_h(l)%target_temp_winter(1:surf_usm_h(l)%ns) )
+    ENDDO
     DO  l = 0, 3
        ALLOCATE ( surf_usm_v(l)%target_temp_summer(1:surf_usm_v(l)%ns) )
@@ -989,6 +930,8 @@
 !-- In case the indoor model is applied, allocate memory for waste heat and indoor temperature.
     IF ( indoor_model )  THEN
-       ALLOCATE ( surf_usm_h%waste_heat(1:surf_usm_h%ns) )
-       surf_usm_h%waste_heat = 0.0_wp
+       DO  l = 0, 1
+          ALLOCATE ( surf_usm_h(l)%waste_heat(1:surf_usm_h(l)%ns) )
+          surf_usm_h(l)%waste_heat = 0.0_wp
+       ENDDO
        DO  l = 0, 3
           ALLOCATE ( surf_usm_v(l)%waste_heat(1:surf_usm_v(l)%ns) )
@@ -998,36 +941,41 @@
 !
 !-- Allocate flag indicating ground floor level surface elements
-    ALLOCATE ( surf_usm_h%ground_level(1:surf_usm_h%ns) )
+    DO  l = 0, 1
+       ALLOCATE ( surf_usm_h(l)%ground_level(1:surf_usm_h(l)%ns) )
+    ENDDO
     DO  l = 0, 3
        ALLOCATE ( surf_usm_v(l)%ground_level(1:surf_usm_v(l)%ns) )
     ENDDO
 !
-!--  Allocate arrays for relative surface fraction.
-!--  0 - wall fraction, 1 - green fraction, 2 - window fraction
-     ALLOCATE ( surf_usm_h%frac(1:surf_usm_h%ns,0:2) )
-     surf_usm_h%frac = 0.0_wp
-     DO  l = 0, 3
-        ALLOCATE ( surf_usm_v(l)%frac(1:surf_usm_v(l)%ns,0:2) )
-        surf_usm_v(l)%frac = 0.0_wp
-     ENDDO
+!-- Allocate arrays for relative surface fraction.
+!-- 0 - wall fraction, 1 - green fraction, 2 - window fraction
+    DO  l = 0, 1
+       ALLOCATE ( surf_usm_h(l)%frac(1:surf_usm_h(l)%ns,0:2) )
+       surf_usm_h(l)%frac = 0.0_wp
+    ENDDO
+    DO  l = 0, 3
+       ALLOCATE ( surf_usm_v(l)%frac(1:surf_usm_v(l)%ns,0:2) )
+       surf_usm_v(l)%frac = 0.0_wp
+    ENDDO
 
 !
 !-- Wall and roof surface parameters. First for horizontal surfaces
-    ALLOCATE ( surf_usm_h%isroof_surf(1:surf_usm_h%ns)        )
-    ALLOCATE ( surf_usm_h%lambda_surf(1:surf_usm_h%ns)        )
-    ALLOCATE ( surf_usm_h%lambda_surf_window(1:surf_usm_h%ns) )
-    ALLOCATE ( surf_usm_h%lambda_surf_green(1:surf_usm_h%ns)  )
-    ALLOCATE ( surf_usm_h%c_surface(1:surf_usm_h%ns)          )
-    ALLOCATE ( surf_usm_h%c_surface_window(1:surf_usm_h%ns)   )
-    ALLOCATE ( surf_usm_h%c_surface_green(1:surf_usm_h%ns)    )
-    ALLOCATE ( surf_usm_h%transmissivity(1:surf_usm_h%ns)     )
-    ALLOCATE ( surf_usm_h%lai(1:surf_usm_h%ns)                )
-    ALLOCATE ( surf_usm_h%emissivity(1:surf_usm_h%ns,0:2)     )
-    ALLOCATE ( surf_usm_h%r_a(1:surf_usm_h%ns)                )
-    ALLOCATE ( surf_usm_h%r_a_green(1:surf_usm_h%ns)          )
-    ALLOCATE ( surf_usm_h%r_a_window(1:surf_usm_h%ns)         )
-    ALLOCATE ( surf_usm_h%green_type_roof(1:surf_usm_h%ns)    )
-    ALLOCATE ( surf_usm_h%r_s(1:surf_usm_h%ns)                )
-
+    DO  l = 0, 1
+       ALLOCATE ( surf_usm_h(l)%isroof_surf(1:surf_usm_h(l)%ns)        )
+       ALLOCATE ( surf_usm_h(l)%lambda_surf(1:surf_usm_h(l)%ns)        )
+       ALLOCATE ( surf_usm_h(l)%lambda_surf_window(1:surf_usm_h(l)%ns) )
+       ALLOCATE ( surf_usm_h(l)%lambda_surf_green(1:surf_usm_h(l)%ns)  )
+       ALLOCATE ( surf_usm_h(l)%c_surface(1:surf_usm_h(l)%ns)          )
+       ALLOCATE ( surf_usm_h(l)%c_surface_window(1:surf_usm_h(l)%ns)   )
+       ALLOCATE ( surf_usm_h(l)%c_surface_green(1:surf_usm_h(l)%ns)    )
+       ALLOCATE ( surf_usm_h(l)%transmissivity(1:surf_usm_h(l)%ns)     )
+       ALLOCATE ( surf_usm_h(l)%lai(1:surf_usm_h(l)%ns)                )
+       ALLOCATE ( surf_usm_h(l)%emissivity(1:surf_usm_h(l)%ns,0:2)     )
+       ALLOCATE ( surf_usm_h(l)%r_a(1:surf_usm_h(l)%ns)                )
+       ALLOCATE ( surf_usm_h(l)%r_a_green(1:surf_usm_h(l)%ns)          )
+       ALLOCATE ( surf_usm_h(l)%r_a_window(1:surf_usm_h(l)%ns)         )
+       ALLOCATE ( surf_usm_h(l)%green_type_roof(1:surf_usm_h(l)%ns)    )
+       ALLOCATE ( surf_usm_h(l)%r_s(1:surf_usm_h(l)%ns)                )
+    ENDDO
 !
 !-- For vertical surfaces.
